Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessHyperparameterInitializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessHyperparameterInitializer.cs	(revision 8396)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessHyperparameterInitializer.cs	(revision 8396)
@@ -0,0 +1,91 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableClass]
+  [Item(Name = "GaussianProcessHyperparameterInitializer",
+    Description = "Initializers the hyperparameter vector based on the mean function, covariance function, and number of allowed input variables.")]
+  public sealed class GaussianProcessHyperparameterInitializer : SingleSuccessorOperator {
+    private const string MeanFunctionParameterName = "MeanFunction";
+    private const string CovarianceFunctionParameterName = "CovarianceFunction";
+    private const string ProblemDataParameterName = "ProblemData";
+    private const string HyperparameterParameterName = "Hyperparameter";
+
+    #region Parameter Properties
+    // in
+    public ILookupParameter<IMeanFunction> MeanFunctionParameter {
+      get { return (ILookupParameter<IMeanFunction>)Parameters[MeanFunctionParameterName]; }
+    }
+    public ILookupParameter<ICovarianceFunction> CovarianceFunctionParameter {
+      get { return (ILookupParameter<ICovarianceFunction>)Parameters[CovarianceFunctionParameterName]; }
+    }
+    public ILookupParameter<IDataAnalysisProblemData> ProblemDataParameter {
+      get { return (ILookupParameter<IDataAnalysisProblemData>)Parameters[ProblemDataParameterName]; }
+    }
+    // out
+    public ILookupParameter<RealVector> HyperparameterParameter {
+      get { return (ILookupParameter<RealVector>)Parameters[HyperparameterParameterName]; }
+    }
+    #endregion
+
+    #region Properties
+    private IMeanFunction MeanFunction { get { return MeanFunctionParameter.ActualValue; } }
+    private ICovarianceFunction CovarianceFunction { get { return CovarianceFunctionParameter.ActualValue; } }
+    private IDataAnalysisProblemData ProblemData { get { return ProblemDataParameter.ActualValue; } }
+    #endregion
+
+    [StorableConstructor]
+    private GaussianProcessHyperparameterInitializer(bool deserializing) : base(deserializing) { }
+    private GaussianProcessHyperparameterInitializer(GaussianProcessHyperparameterInitializer original, Cloner cloner) : base(original, cloner) { }
+    public GaussianProcessHyperparameterInitializer()
+      : base() {
+      // in
+      Parameters.Add(new LookupParameter<IMeanFunction>(MeanFunctionParameterName, "The mean function for the Gaussian process model."));
+      Parameters.Add(new LookupParameter<ICovarianceFunction>(CovarianceFunctionParameterName, "The covariance function for the Gaussian process model."));
+      Parameters.Add(new LookupParameter<IDataAnalysisProblemData>(ProblemDataParameterName, "The input data for the Gaussian process."));
+      // out
+      Parameters.Add(new LookupParameter<RealVector>(HyperparameterParameterName, "The initial hyperparameter vector for the Gaussian process model."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GaussianProcessHyperparameterInitializer(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      var inputVariablesCount = ProblemData.AllowedInputVariables.Count();
+      int l = 1 + MeanFunction.GetNumberOfParameters(inputVariablesCount) +
+              CovarianceFunction.GetNumberOfParameters(inputVariablesCount);
+      HyperparameterParameter.ActualValue = new RealVector(l);
+      return base.Apply();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessModelCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessModelCreator.cs	(revision 8386)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessModelCreator.cs	(revision 8396)
@@ -23,4 +23,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Operators;
@@ -42,6 +43,6 @@
     #region Parameter Properties
     // in
-    public ILookupParameter<DoubleArray> HyperparameterParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters[HyperparameterParameterName]; }
+    public ILookupParameter<RealVector> HyperparameterParameter {
+      get { return (ILookupParameter<RealVector>)Parameters[HyperparameterParameterName]; }
     }
     public ILookupParameter<IMeanFunction> MeanFunctionParameter {
@@ -55,6 +56,6 @@
       get { return (ILookupParameter<IGaussianProcessModel>)Parameters[ModelParameterName]; }
     }
-    public ILookupParameter<DoubleArray> HyperparameterGradientsParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters[HyperparameterGradientsParameterName]; }
+    public ILookupParameter<RealVector> HyperparameterGradientsParameter {
+      get { return (ILookupParameter<RealVector>)Parameters[HyperparameterGradientsParameterName]; }
     }
     public ILookupParameter<DoubleValue> NegativeLogLikelihoodParameter {
@@ -65,5 +66,5 @@
 
     #region Properties
-    protected DoubleArray Hyperparameter { get { return HyperparameterParameter.ActualValue; } }
+    protected RealVector Hyperparameter { get { return HyperparameterParameter.ActualValue; } }
     protected IMeanFunction MeanFunction { get { return MeanFunctionParameter.ActualValue; } }
     protected ICovarianceFunction CovarianceFunction { get { return CovarianceFunctionParameter.ActualValue; } }
@@ -76,10 +77,10 @@
       : base() {
       // in
-      Parameters.Add(new LookupParameter<DoubleArray>(HyperparameterParameterName, "The hyperparameters for the Gaussian process model."));
+      Parameters.Add(new LookupParameter<RealVector>(HyperparameterParameterName, "The hyperparameters for the Gaussian process model."));
       Parameters.Add(new LookupParameter<IMeanFunction>(MeanFunctionParameterName, "The mean function for the Gaussian process model."));
       Parameters.Add(new LookupParameter<ICovarianceFunction>(CovarianceFunctionParameterName, "The covariance function for the Gaussian process model."));
       // out
       Parameters.Add(new LookupParameter<IGaussianProcessModel>(ModelParameterName, "The resulting Gaussian process model"));
-      Parameters.Add(new LookupParameter<DoubleArray>(HyperparameterGradientsParameterName, "The gradients of the hyperparameters for the produced Gaussian process model (necessary for hyperparameter optimization)"));
+      Parameters.Add(new LookupParameter<RealVector>(HyperparameterGradientsParameterName, "The gradients of the hyperparameters for the produced Gaussian process model (necessary for hyperparameter optimization)"));
       Parameters.Add(new LookupParameter<DoubleValue>(NegativeLogLikelihoodParameterName, "The negative log-likelihood of the produced Gaussian process model given the data."));
     }
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs	(revision 8386)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs	(revision 8396)
@@ -28,4 +28,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -55,4 +56,5 @@
     private const string CovarianceFunctionParameterName = "CovarianceFunction";
     private const string MinimizationIterationsParameterName = "Iterations";
+    private const string ApproximateGradientsParameterName = "ApproximateGradients";
 
     #region parameter properties
@@ -88,4 +90,7 @@
     public GaussianProcessRegression()
       : base() {
+      this.name = ItemName;
+      this.description = ItemDescription;
+
       Problem = new RegressionProblem();
 
@@ -97,30 +102,33 @@
       Parameters.Add(new ConstrainedValueParameter<ICovarianceFunction>(CovarianceFunctionParameterName, "The covariance function to use.",
         new ItemSet<ICovarianceFunction>(covFunctions), covFunctions.First()));
-      Parameters.Add(new ValueParameter<IntValue>(MinimizationIterationsParameterName, "The number of iterations for likelihood optimization with BFGS.", new IntValue(20)));
+      Parameters.Add(new ValueParameter<IntValue>(MinimizationIterationsParameterName, "The number of iterations for likelihood optimization with LM-BFGS.", new IntValue(20)));
+      Parameters.Add(new ValueParameter<BoolValue>(ApproximateGradientsParameterName, "Indicates that gradients should not be approximated (necessary for LM-BFGS).", new BoolValue(false)));
+      Parameters[ApproximateGradientsParameterName].Hidden = true; // should not be changed
 
-      var setParameterLength = new GaussianProcessSetHyperparameterLength();
-      var initializer = new BFGSInitializer();
-      var makeStep = new BFGSMakeStep();
+      var gpInitializer = new GaussianProcessHyperparameterInitializer();
+      var bfgsInitializer = new LbfgsInitializer();
+      var makeStep = new LbfgsMakeStep();
       var branch = new ConditionalBranch();
       var modelCreator = new GaussianProcessRegressionModelCreator();
-      var updateResults = new BFGSUpdateResults();
-      var analyzer = new BFGSAnalyzer();
+      var updateResults = new LbfgsUpdateResults();
+      var analyzer = new LbfgsAnalyzer();
       var finalModelCreator = new GaussianProcessRegressionModelCreator();
-      var finalAnalyzer = new BFGSAnalyzer();
+      var finalAnalyzer = new LbfgsAnalyzer();
       var solutionCreator = new GaussianProcessRegressionSolutionCreator();
 
-      OperatorGraph.InitialOperator = setParameterLength;
+      OperatorGraph.InitialOperator = gpInitializer;
 
-      setParameterLength.CovarianceFunctionParameter.ActualName = CovarianceFunctionParameterName;
-      setParameterLength.MeanFunctionParameter.ActualName = MeanFunctionParameterName;
-      setParameterLength.ProblemDataParameter.ActualName = Problem.ProblemDataParameter.Name;
-      setParameterLength.Successor = initializer;
+      gpInitializer.CovarianceFunctionParameter.ActualName = CovarianceFunctionParameterName;
+      gpInitializer.MeanFunctionParameter.ActualName = MeanFunctionParameterName;
+      gpInitializer.ProblemDataParameter.ActualName = Problem.ProblemDataParameter.Name;
+      gpInitializer.HyperparameterParameter.ActualName = modelCreator.HyperparameterParameter.Name;
+      gpInitializer.Successor = bfgsInitializer;
 
-      initializer.IterationsParameter.ActualName = MinimizationIterationsParameterName;
-      initializer.DimensionParameter.ActualName = setParameterLength.NumberOfHyperparameterParameter.Name;
-      initializer.PointParameter.ActualName = modelCreator.HyperparameterParameter.Name;
-      initializer.Successor = makeStep;
+      bfgsInitializer.IterationsParameter.ActualName = MinimizationIterationsParameterName;
+      bfgsInitializer.PointParameter.ActualName = modelCreator.HyperparameterParameter.Name;
+      bfgsInitializer.ApproximateGradientsParameter.ActualName = ApproximateGradientsParameterName;
+      bfgsInitializer.Successor = makeStep;
 
-      makeStep.BFGSStateParameter.ActualName = initializer.BFGSStateParameter.Name;
+      makeStep.StateParameter.ActualName = bfgsInitializer.StateParameter.Name;
       makeStep.PointParameter.ActualName = modelCreator.HyperparameterParameter.Name;
       makeStep.Successor = branch;
@@ -135,7 +143,8 @@
       modelCreator.Successor = updateResults;
 
-      updateResults.BFGSStateParameter.ActualName = initializer.BFGSStateParameter.Name;
+      updateResults.StateParameter.ActualName = bfgsInitializer.StateParameter.Name;
       updateResults.QualityParameter.ActualName = modelCreator.NegativeLogLikelihoodParameter.Name;
       updateResults.QualityGradientsParameter.ActualName = modelCreator.HyperparameterGradientsParameter.Name;
+      updateResults.ApproximateGradientsParameter.ActualName = ApproximateGradientsParameterName;
       updateResults.Successor = analyzer;
 
@@ -143,5 +152,5 @@
       analyzer.PointParameter.ActualName = modelCreator.HyperparameterParameter.Name;
       analyzer.QualityGradientsParameter.ActualName = modelCreator.HyperparameterGradientsParameter.Name;
-      analyzer.BFGSStateParameter.ActualName = initializer.BFGSStateParameter.Name;
+      analyzer.StateParameter.ActualName = bfgsInitializer.StateParameter.Name;
       analyzer.PointsTableParameter.ActualName = "Hyperparameter table";
       analyzer.QualityGradientsTableParameter.ActualName = "Gradients table";
@@ -152,5 +161,5 @@
       finalModelCreator.MeanFunctionParameter.ActualName = MeanFunctionParameterName;
       finalModelCreator.CovarianceFunctionParameter.ActualName = CovarianceFunctionParameterName;
-      finalModelCreator.HyperparameterParameter.ActualName = initializer.PointParameter.ActualName;
+      finalModelCreator.HyperparameterParameter.ActualName = bfgsInitializer.PointParameter.ActualName;
       finalModelCreator.Successor = finalAnalyzer;
 
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegressionModelCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegressionModelCreator.cs	(revision 8386)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegressionModelCreator.cs	(revision 8396)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Operators;
@@ -65,5 +66,5 @@
       ModelParameter.ActualValue = model;
       NegativeLogLikelihoodParameter.ActualValue = new DoubleValue(model.NegativeLogLikelihood);
-      HyperparameterGradientsParameter.ActualValue = new DoubleArray(model.GetHyperparameterGradients());
+      HyperparameterGradientsParameter.ActualValue = new RealVector(model.GetHyperparameterGradients());
       return base.Apply();
     }
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/Lbfgs.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/Lbfgs.cs	(revision 8396)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/Lbfgs.cs	(revision 8396)
@@ -0,0 +1,146 @@
+
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.TestFunctions;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  /// <summary>
+  /// Limited-Memory BFGS optimization algorithm.
+  /// </summary>
+  [Item("LM-BFGS", "The limited-memory BFGS (BroydenFletcherGoldfarbShanno) optimization algorithm.")]
+  [Creatable("Algorithms")]
+  [StorableClass]
+  public sealed class LbfgsAlgorithm : HeuristicOptimizationEngineAlgorithm, IStorableContent {
+    public override Type ProblemType {
+      get { return typeof(SingleObjectiveTestFunctionProblem); }
+    }
+
+    public new SingleObjectiveTestFunctionProblem Problem {
+      get { return (SingleObjectiveTestFunctionProblem)base.Problem; }
+      set { base.Problem = value; }
+    }
+
+    public string Filename { get; set; }
+
+    private const string MaxIterationsParameterName = "MaxIterations";
+    private const string ApproximateGradientsParameterName = "ApproximateGradients";
+
+    #region parameter properties
+    public IValueParameter<IntValue> MaxIterationsParameter {
+      get { return (IValueParameter<IntValue>)Parameters[MaxIterationsParameterName]; }
+    }
+    #endregion
+    #region properties
+    public int MaxIterations {
+      set { MaxIterationsParameter.Value.Value = value; }
+      get { return MaxIterationsParameter.Value.Value; }
+    }
+    #endregion
+    [StorableConstructor]
+    private LbfgsAlgorithm(bool deserializing) : base(deserializing) { }
+    private LbfgsAlgorithm(LbfgsAlgorithm original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public LbfgsAlgorithm()
+      : base() {
+      this.name = ItemName;
+      this.description = ItemDescription;
+
+      Problem = new SingleObjectiveTestFunctionProblem();
+
+      Parameters.Add(new ValueParameter<IntValue>(MaxIterationsParameterName, "The maximal number of iterations for.", new IntValue(20)));
+      Parameters.Add(new ValueParameter<BoolValue>(ApproximateGradientsParameterName, "Indicates that gradients should be approximated.", new BoolValue(true)));
+      Parameters[ApproximateGradientsParameterName].Hidden = true; // should not be changed
+
+      var randomCreator = new RandomCreator();
+      var solutionCreator = new Placeholder();
+      var bfgsInitializer = new LbfgsInitializer();
+      var makeStep = new LbfgsMakeStep();
+      var branch = new ConditionalBranch();
+      var evaluator = new Placeholder();
+      var updateResults = new LbfgsUpdateResults();
+      var analyzer = new LbfgsAnalyzer();
+      var finalAnalyzer = new LbfgsAnalyzer();
+
+      OperatorGraph.InitialOperator = randomCreator;
+
+      randomCreator.Successor = solutionCreator;
+
+      solutionCreator.OperatorParameter.ActualName = Problem.SolutionCreatorParameter.Name;
+      solutionCreator.Successor = bfgsInitializer;
+
+      bfgsInitializer.IterationsParameter.ActualName = MaxIterationsParameterName;
+      bfgsInitializer.PointParameter.ActualName = Problem.SolutionCreator.RealVectorParameter.ActualName;
+      bfgsInitializer.ApproximateGradientsParameter.ActualName = ApproximateGradientsParameterName;
+      bfgsInitializer.Successor = makeStep;
+
+      makeStep.StateParameter.ActualName = bfgsInitializer.StateParameter.Name;
+      makeStep.PointParameter.ActualName = bfgsInitializer.PointParameter.ActualName;
+      makeStep.Successor = branch;
+
+      branch.ConditionParameter.ActualName = makeStep.TerminationCriterionParameter.Name;
+      branch.FalseBranch = evaluator;
+      branch.TrueBranch = finalAnalyzer;
+
+      evaluator.OperatorParameter.ActualName = Problem.EvaluatorParameter.Name;
+      evaluator.Successor = updateResults;
+
+      updateResults.StateParameter.ActualName = bfgsInitializer.StateParameter.Name;
+      updateResults.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.Name;
+      updateResults.ApproximateGradientsParameter.ActualName = ApproximateGradientsParameterName;
+      updateResults.Successor = analyzer;
+
+      analyzer.QualityParameter.ActualName = updateResults.QualityParameter.ActualName;
+      analyzer.PointParameter.ActualName = makeStep.PointParameter.ActualName;
+      analyzer.StateParameter.ActualName = bfgsInitializer.StateParameter.Name;
+      analyzer.Successor = makeStep;
+
+      finalAnalyzer.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.Name;
+      finalAnalyzer.PointParameter.ActualName = makeStep.PointParameter.ActualName;
+      finalAnalyzer.PointsTableParameter.ActualName = analyzer.PointsTableParameter.ActualName;
+      finalAnalyzer.QualityGradientsTableParameter.ActualName = analyzer.QualityGradientsTableParameter.ActualName;
+      finalAnalyzer.QualitiesTableParameter.ActualName = analyzer.QualitiesTableParameter.ActualName;
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LbfgsAlgorithm(this, cloner);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/LbfgsAnalyzer.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/LbfgsAnalyzer.cs	(revision 8396)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/LbfgsAnalyzer.cs	(revision 8396)
@@ -0,0 +1,170 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableClass]
+  [Item(Name = "LBFGS Analyzer", Description = "Analyzer to collect results for the LM-BFGS algorithm.")]
+  public sealed class LbfgsAnalyzer : SingleSuccessorOperator, IAnalyzer {
+    private const string PointParameterName = "Point";
+    private const string QualityGradientsParameterName = "QualityGradients";
+    private const string QualityParameterName = "Quality";
+    private const string ResultCollectionParameterName = "Results";
+    private const string QualitiesTableParameterName = "Qualities";
+    private const string PointsTableParameterName = "PointTable";
+    private const string QualityGradientsTableParameterName = "QualityGradientsTable";
+    private const string StateParameterName = "State";
+    private const string ApproximateGradientsParameterName = "ApproximateGradients";
+
+    #region Parameter Properties
+    public ILookupParameter<RealVector> QualityGradientsParameter {
+      get { return (ILookupParameter<RealVector>)Parameters[QualityGradientsParameterName]; }
+    }
+    public ILookupParameter<RealVector> PointParameter {
+      get { return (ILookupParameter<RealVector>)Parameters[PointParameterName]; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters[QualityParameterName]; }
+    }
+    public ILookupParameter<ResultCollection> ResultCollectionParameter {
+      get { return (ILookupParameter<ResultCollection>)Parameters[ResultCollectionParameterName]; }
+    }
+    public ILookupParameter<DataTable> QualitiesTableParameter {
+      get { return (ILookupParameter<DataTable>)Parameters[QualitiesTableParameterName]; }
+    }
+    public ILookupParameter<DataTable> PointsTableParameter {
+      get { return (ILookupParameter<DataTable>)Parameters[PointsTableParameterName]; }
+    }
+    public ILookupParameter<DataTable> QualityGradientsTableParameter {
+      get { return (ILookupParameter<DataTable>)Parameters[QualityGradientsTableParameterName]; }
+    }
+    public ILookupParameter<LbfgsState> StateParameter {
+      get { return (ILookupParameter<LbfgsState>)Parameters[StateParameterName]; }
+    }
+    public ILookupParameter<BoolValue> ApproximateGradientsParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters[ApproximateGradientsParameterName]; }
+    }
+    #endregion
+
+    #region Properties
+    private RealVector QualityGradients { get { return QualityGradientsParameter.ActualValue; } }
+    private RealVector Point { get { return PointParameter.ActualValue; } }
+    private DoubleValue Quality { get { return QualityParameter.ActualValue; } }
+    private ResultCollection ResultCollection { get { return ResultCollectionParameter.ActualValue; } }
+    private BoolValue ApproximateGradients { get { return ApproximateGradientsParameter.ActualValue; } }
+
+    public bool EnabledByDefault {
+      get { return true; }
+    }
+
+    #endregion
+
+    [StorableConstructor]
+    private LbfgsAnalyzer(bool deserializing) : base(deserializing) { }
+    private LbfgsAnalyzer(LbfgsAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public LbfgsAnalyzer()
+      : base() {
+      // in
+      Parameters.Add(new LookupParameter<RealVector>(PointParameterName, "The current point of the function to optimize."));
+      Parameters.Add(new LookupParameter<RealVector>(QualityGradientsParameterName, "The current gradients of the function to optimize."));
+      Parameters.Add(new LookupParameter<DoubleValue>(QualityParameterName, "The current value of the function to optimize."));
+      Parameters.Add(new LookupParameter<DataTable>(QualitiesTableParameterName, "The table of all visited quality values."));
+      Parameters.Add(new LookupParameter<DataTable>(PointsTableParameterName, "The table of all visited points."));
+      Parameters.Add(new LookupParameter<DataTable>(QualityGradientsTableParameterName, "The table of all visited gradient values."));
+      Parameters.Add(new LookupParameter<LbfgsState>(StateParameterName, "The state of the LM-BFGS optimization algorithm."));
+      Parameters.Add(new LookupParameter<BoolValue>(ApproximateGradientsParameterName,
+                                              "Flag that indicates if gradients should be approximated."));
+
+      // in & out
+      Parameters.Add(new LookupParameter<ResultCollection>(ResultCollectionParameterName, "The result collection of the algorithm."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LbfgsAnalyzer(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (StateParameter.ActualValue.State.xupdated) {
+        var f = Quality.Value;
+        double[] g;
+        if (ApproximateGradients.Value) {
+          g = StateParameter.ActualValue.State.g;
+        } else {
+          g = QualityGradients.ToArray();
+        }
+        var x = Point.ToArray();
+        var resultCollection = ResultCollection;
+
+        // create and add tables on the first time
+        if (QualitiesTableParameter.ActualValue == null) {
+          QualitiesTableParameter.ActualValue = new DataTable(QualityParameter.ActualName);
+          PointsTableParameter.ActualValue = new DataTable(PointParameter.ActualName);
+          QualityGradientsTableParameter.ActualValue = new DataTable(QualityGradientsParameter.ActualName);
+
+          QualitiesTableParameter.ActualValue.Rows.Add(new DataRow(QualityParameter.ActualName));
+
+          resultCollection.Add(new Result(QualitiesTableParameter.ActualName,
+                                          QualitiesTableParameter.ActualValue));
+          resultCollection.Add(new Result(PointsTableParameter.ActualName,
+                                          PointsTableParameter.ActualValue));
+          resultCollection.Add(new Result(QualityGradientsTableParameter.ActualName,
+                                          QualityGradientsTableParameter.ActualValue));
+          resultCollection.Add(new Result(QualityParameter.ActualName, QualityParameter.ActualValue));
+        }
+
+        // update
+        var functionValueRow = QualitiesTableParameter.ActualValue.Rows[QualityParameter.ActualName];
+        resultCollection[QualityParameter.ActualName].Value = Quality;
+        functionValueRow.Values.Add(f);
+
+        AddValues(g, QualityGradientsTableParameter.ActualValue);
+        AddValues(x, PointsTableParameter.ActualValue);
+      }
+      return base.Apply();
+    }
+
+    private void AddValues(double[] x, DataTable dataTable) {
+      if (!dataTable.Rows.Any()) {
+        for (int i = 0; i < x.Length; i++) {
+          var newRow = new DataRow("x" + i);
+          newRow.Values.Add(x[i]);
+          dataTable.Rows.Add(newRow);
+        }
+      } else {
+        for (int i = 0; i < x.Length; i++) {
+          dataTable.Rows.ElementAt(i).Values.Add(x[i]);
+        }
+      }
+    }
+  }
+}
